#!/usr/bin/perl
# FriendsOnline v0.9c
# based on Clarn's chomp-Routine

# Required Librariers
# --------------------------------------------------------
eval {
    ($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1");    # Get the script location: UNIX /
    ($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1");    # Get the script location: Windows \

    	require "buddy.cfg";
	require "Styles.file";
	require "UltBB.setup";
};


###################################################################
sub login {
###################################################################
&print_header1;
print<<"END_OF_TEsT";
<html><head><title>FriendsOnline 0.9a</title>$HeaderInsert</head><body bgcolor="$BGColor" text="$TextColor" link="$LinkColor" alink="$ActiveLinkColor" vlink="$VisitedLinkColor">
<font face="$FontFace" size="$TextSize">
<center>
<p>
<FONT color="$BBTitleFontColor" size="1"><B>FriendsOnline 0.9a</B></FONT><br>		
<table cellspacing="1">
<form action="$viewprivate" method="GET">
<table cellpadding=5 width=70% align=center>
<tr bgcolor=$TableColorStrip><td colspan=3><b><font color="$TableStripTextColor" face="$FontFace" size="$TextSize"><b>Login:</b></font></b></td></tr>
<tr $AltColumnColor1><td valign=middle><font face="$FontFace" size="$TextSize"><b>UserName:</b></font></td><td colspan=2 valign=middle><input type=text name=user value="$in{'user'}" size=25></td></tr>
<tr $AltColumnColor1><td valign=middle><font face="$FontFace" size="$TextSize"><b>Password:</b></font></td><td valign=middle><input type=password name=pass value="$in{'pass'}" size=25></td><td valign=middle><input type="submit" value="Login"></td></tr>
</form>		
</table>
<br><br><br>
</center>
</font>
</html>
END_OF_TEsT
&print_footer;
exit;
}

###################################################################
sub valid_user {
###################################################################

$members=0;

          open (NAME,"$MembersPath/memberslist.cgi");

		LINE: while (<NAME>)
			{
			next LINE if (/^#/);		# Skip comment lines.
			next LINE if (/^\s*$/);		# Skip blank lines.

                        @found=split (/\|\!\!\|/);

                      if ($found[0] eq $user) {
 $passfile = "$found[1]";
 $passfile =~ s/\n//g;
 $members = 1 }

                      } #end of while

                close (NAME);


unless ($members > 0) {

 &print_header1;
 print "<br><br><p align=center><FONT SIZE=$TextSize FACE=$FontFace color=$TimeColor><b>We're sorry, but the username you've entered is not a registered on our BB. Please double-check the spelling.</b></font><p>\n";
&print_footer;
exit;
} # end of unless
}

###################################################################
sub check_pm_status {
###################################################################

if (-e "$db_dir/$user.pref") {
	open (PREFS,"$db_dir/$user.pref");
    LINE: while(<PREFS>){
		next LINE if (/^#/);		# Skip comment lines.
		next LINE if (/^\s*$/);		# Skip blank lines.
        @data=split (/\|/);
		$prefs{$data[4]} = $data[5];	
	}
   close (PREFS);
}
if ($prefs{'status'} eq "off") {
 &print_header1;
 print qq(<br><br><p align=center><FONT SIZE=$TextSize FACE=$FontFace color=$TimeColor><b>We're sorry, but you have private messages disabled.<br>Go to your <A HREF="$cgi_url/$privateprefs">PM Prefrences</A> page to turn Pm back on.</b></FONT><p>\n);
&print_footer;
exit;
}
}
###################################################################
sub valid_recip {
###################################################################

$members=0;

          open (NAME,"$MembersPath/memberslist.cgi");

		LINE: while (<NAME>)
			{
			next LINE if (/^#/);		# Skip comment lines.
			next LINE if (/^\s*$/);		# Skip blank lines.

                        @found=split (/\|\!\!\|/);

                      if ($found[0] eq $to) {
 $members = 1 }

                      } #end of while

                close (NAME);


unless ($members > 0) { 
 &print_header1;
 print "<p align=center><FONT SIZE=$TextSize FACE=$FontFace color=$TimeColor><b>We're sorry, but the recipient you've entered is not a registered member of our BB. Please double-check the spelling.</b></font><p>\n";
&print_footer;
exit;
} # end of unless

if (-e "$db_dir/$to.pref") {
	open (PREFS,"$db_dir/$to.pref");
    LINE: while(<PREFS>){
		next LINE if (/^#/);		# Skip comment lines.
		next LINE if (/^\s*$/);		# Skip blank lines.
        @data=split (/\|/);
		$prefs{$data[4]} = $data[5];
		$prefs{$data[6]} = $data[7];	
	}
   close (PREFS);
}
if ($prefs{'status'} eq "off") {
 &print_header1;
 print "<br><br><p align=center><FONT SIZE=$TextSize FACE=$FontFace color=$TimeColor><b>We're sorry, but the recipient you've entered has disabled private messages.</b></font><p>\n";
&print_footer;
exit;
}

if ($IgnoreAllow eq "yes") {
foreach (split(/,/, $prefs{Ignore})) {
	if ($_ eq $user) {
		&print_header1;
		print "<br><br><p align=center><FONT SIZE=$TextSize FACE=$FontFace color=$TimeColor><b>We're sorry, but the recipient you've entered does not wish to recieve private messages from you.</b></font><p>\n";
		&print_footer;
		exit;
	}
}
}

}



###################################################################
sub valid_pass {
###################################################################


          open (PASS,"$MembersPath/$passfile.cgi") or die("Unable to open $MembersPath/$passfile.cgi");

$counter = 0;
	
          LINE: while(<PASS>){
		$counter = $counter + 1;
		next LINE if (/^#/);		# Skip comment lines.
		next LINE if (/^\s*$/);		# Skip blank lines.

          @pass=split(/\n/);

          if (($counter eq 2) && ($pass[0] eq $pass)) { $newpass = 1;}
		  if ($counter eq 13) {$sig = $pass[0];}

          } #end of while

          close (PASS);

unless ($newpass > 0) {

&print_header1;

print "<br><br><p align=center><FONT SIZE=$TextSize FACE=$FontFace color=$TimeColor><b>The password you have entered is incorrect. Please double-check the spelling.</b></font><p>\n";
&print_footer;
exit;
} # end of unless
}


###################################################################
sub unix_to_date {
###################################################################

    my $time   = shift;
    my ($sec, $min, $hour, $day, $mon, $year, $dweek, $dyear, $tz) = localtime $time;
    my @months = qw!Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec!;
    $year      = $year + 1900;    
    return "$day-$months[$mon]-$year";
}

###################################################################
sub parse_form {
###################################################################

    my (@pairs, %in);
    my ($buffer, $pair, $name, $value); 
        
    if ($ENV{'REQUEST_METHOD'} eq 'GET') {
        @pairs = split(/&/, $ENV{'QUERY_STRING'});
    }
    elsif ($ENV{'REQUEST_METHOD'} eq 'POST') {
        read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
        @pairs = split(/&/, $buffer);
    }
    else {
        &cgierr('You cant run this script from telnet/shell.');
    }
    
    PAIR: foreach $pair (@pairs) {
        ($name, $value) = split(/=/, $pair);
         
        $name =~ tr/+/ /;
        $name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

        $value =~ tr/+/ /;
        $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

        ($value eq "---") and next PAIR; 
        exists $in{$name} ? ($in{$name} .= "~~$value") : ($in{$name}  = $value);
    }
    return %in;
}

##################################################################
sub print_header1 {
##################################################################

print ("Content-type: text/html\n\n");
print ("$Header");
  open (HEADER,"$basepath/$header") || print "Could not open $basepath/$header $! \n";
  while (<HEADER>) {
  print $_;
  } # end of while
  close (HEADER);
} # end of sub


##################################################################
sub print_footer {
##################################################################
print "<center>";
&PageBottomHTML;
print "<p align=center><FONT COLOR=$TimeColor size=1 FACE=$FontFace></font></p>";
print "$id\n";
} # end of sub

##################################################################
sub validate_record {
##################################################################

    my ($col, @input_err, $errstr, $err, $line, @lines, @data); 
    my (%rec) = @_;

    if ($rec{'add_record'})     {       # don't need to worry about duplicate key if modifying  
        open (DB, "<$db_dir/$user.db") or &cgierr("error in validate_records. unable to open db file: $db_file_name.\nReason: $!");        
        if ($db_use_flock) { flock(DB, 1); }        
        LINE: while (<DB>) {
            (/^#/)      and next LINE;
            (/^\s*$/)   and next LINE;
            chomp;      
            @data = &split_decode($_);
            ($data[$db_key_pos] eq $rec{$db_key}) and return "duplicate key error";
        }
        close DB;
    }   
    foreach $col (@db_cols) {
        if ($rec{$col} =~ /^\s*$/) {            # entry is null or only whitespace
            ($db_not_null{$col}) and            # entry is not allowed to be null.
                push(@input_err, "$col (Can not be left blank)");  # so let's add it as an error
        }
        else {                                  # else entry is not null.
            ($db_valid_types{$col} && !($rec{$col} =~ /$db_valid_types{$col}/)) and
                push(@input_err, "$col (Invalid format)");  # but has failed validation.
            (length($rec{$col}) > $db_lengths{$col}) and
                push (@input_err, "$col (Too long. Max length: $db_lengths{$col})");
            if ($db_sort{$col} eq "date") {     
                push (@input_err, "$col (Invalid date format)") unless &date_to_unix($rec{$col});
            }
        }
    }   
    if ($#input_err+1 > 0) {                    # since there are errors, let's build
        foreach $err (@input_err) {             # a string listing the errors
            $errstr .= "<li>$err";              # and return it.
        }
        return "<ul>$errstr</ul>";
    }
    else {
        return "ok";                            # no errors, return ok.
    }
}


##################################################################
sub array_to_hash {
##################################################################

    my ($hit, @array) = @_;
    my ($i);    
    return map { $db_cols[$i] => $array[$hit * ($#db_cols+1) + $i++] } @_;
}


##################################################################
sub join_encode {
##################################################################
    my %hash = @_;
    my ($tmp, $col, $output);   

    foreach $col (@db_cols) {               
        $tmp = $hash{$col};
        $tmp =~ s/^\s+//g;              # Trim leading blanks...
        $tmp =~ s/\s+$//g;              # Trim trailing blanks...
        $tmp =~ s/\Q$db_delim\E/~~/og;  # Change delimeter to ~~ symbol.
        $tmp =~ s/\n/``/g;              # Change newline to `` symbol.
        $tmp =~ s/\r//g;                # Remove Windows linefeed character.
        $output .= $tmp . $db_delim;    # Build Output.
    }
    chop $output;       # remove extra delimeter.
    $output .= "\n";    # add linefeed char.
    return $output;
}

##################################################################
sub split_decode {
##################################################################

    my ($input) = shift;    
    my (@array) = split (/\Q$db_delim\E/o, $input, $#db_cols+1);
    foreach (@array) {
        s/~~/$db_delim/g;   # Retrieve Delimiter..
        s/``/\n/g;          # Change '' back to newlines..
    }   
    return @array;
}


##################################################################
sub parse_form {
##################################################################
# Parses the form input and returns a hash with all the name
# value pairs. Removes any field with "---" as a value 
# (as this denotes an empty SELECT field.
#
    my (@pairs, %in);
    my ($buffer, $pair, $name, $value); 
        
    if ($ENV{'REQUEST_METHOD'} eq 'GET') {
        @pairs = split(/&/, $ENV{'QUERY_STRING'});
    }
    elsif ($ENV{'REQUEST_METHOD'} eq 'POST') {
        read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
        @pairs = split(/&/, $buffer);
    }
    else {
        &cgierr('You cant run this script from telnet/shell.');
    }
    
    PAIR: foreach $pair (@pairs) {
        ($name, $value) = split(/=/, $pair);
         
        $name =~ tr/+/ /;
        $name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

        $value =~ tr/+/ /;
        $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

        ($value eq "---") and next PAIR; 
        exists $in{$name} ? ($in{$name} .= "~~$value") : ($in{$name}  = $value);
    }
    return %in;
}

##################################################################
sub cgierr {
##################################################################
# Displays any errors and prints out FORM and ENVIRONMENT 
# information. Useful for debugging.
#
    if (!$html_headers_printed) {
        print "Content-type: text/html\n\n";
        $html_headers_printed = 1;
    }
    print "<PRE>\n\nCGI ERROR\n==========================================\n";
    $_[0]      and print "Error Message       : $_[0]\n";   
    $0         and print "Script Location     : $0\n";
    $]         and print "Perl Version        : $]\n";  
    
    print "\nForm Variables\n-------------------------------------------\n";
    foreach $key (sort keys %in) {
        my $space = " " x (20 - length($key));
        print "$key$space: $in{$key}\n";
    }
    print "\nEnvironment Variables\n-------------------------------------------\n";
    foreach $env (sort keys %ENV) {
        my $space = " " x (20 - length($env));
        print "$env$space: $ENV{$env}\n";
    }
    print "\n</PRE>";
    exit -1;
}


##################################################################
sub get_count {
##################################################################

   open (DB,"$db_dir/$to.count") or &make_count;
   $count = <DB>;
   $ID = $count;
   close(DB);
return $count;
}

##################################################################
sub get_count_sent {
##################################################################

   open (DB,"$db_dir/$user.count") or &make_countsent;
   $countsent = <DB>;
   $ID = $countsent;
   close(DB);
return $countsent;
}

##################################################################
sub make_count {
##################################################################

$count=0;
$ID=0;
   open (DB,">$db_dir/$to.count") or &cgierr;
   flock DB, $EXCLUSIVE;        # Lock the file so nobody else uses it.
    seek DB, 0, 2;
    print DB $count;
   flock DB, $UNLOCK;
   close(DB);
return $count;
}

##################################################################
sub make_countsent {
##################################################################

$countsent=0;
$ID=0;
   open (DB,">$db_dir/$user.count") or &cgierr;
   flock DB, $EXCLUSIVE;        # Lock the file so nobody else uses it.
    seek DB, 0, 2;
    print DB $countsent;
   flock DB, $UNLOCK;
   close(DB);
return $countsent;
}

##################################################################
sub up_count {
##################################################################

   open (DB,">$db_dir/$to.count") or die "Error: $!\n";
   $count++;
 flock(DB, 2)  or die "Error: $!\n";
                print DB $count;               
            close DB;           # automatically removes file lock
return;  
}

##################################################################
sub up_count_sent {
##################################################################

   open (DB,">$db_dir/$user.count") or die "Error: $!\n";
   $countsent++;
 flock(DB, 2)  or die "Error: $!\n";
                print DB $countsent;               
            close DB;           # automatically removes file lock
return;  
}

##################################################################
sub htmlify {
##################################################################

my $html = shift;
$html =~ s/&quot;/\!QUT\!/g;
$html =~ s/&/\!AMP\!/g;
$html =~ s/"/\!QUT\!/g;
$html =~ s/\?/\!QUS\!/g;
$html =~ s/=/\!EQUL\!/g;
$html =~ s/'/\!APO\!/g;
$html =~ s/\+/\!PLS\!/g;
$html =~ s/\#/\!NMB\!/g;
$html =~ s/\n/\!br\!/g;
return ($html);

}

##################################################################
sub unhtmlify {
##################################################################

my $unhtml = shift;
$unhtml =~ s/\!AMP\!/\&/g;
$unhtml =~ s/\!QUT\!/\"/g;
$unhtml =~ s/\!QUS\!/\?/g;
$unhtml =~ s/\!EQUL\!/=/g;
$unhtml =~ s/\!APO\!/'/g;
$unhtml =~ s/\!PLS\!/\+/g;
$unhtml =~ s/\!NMB\!/\#/g;
$unhtml =~ s/\!br\!/<br>/g;
$unhtml =~ s/\\n/<br>/g;

return ($unhtml);
}

##################################################################
sub ubbcode {
##################################################################

my $ubbcode = shift;

$ubbcode =~ s/(\[URL\])(http:\/\/\S+?)(\[\/URL\])/ <A HREF="$2" TARGET=_blank>$2<\/A> /isg;
$ubbcode =~ s/(\[URL\])(\S+?)(\[\/URL\])/ <A HREF="http:\/\/$2" TARGET=_blank>$2<\/A> /isg;
$ubbcode =~ s/(\[EMAIL\])(\S+\@\S+?)(\[\/EMAIL\])/ <A HREF="mailto:$2">$2<\/A> /isg;
$ubbcode =~ s,(\[code\])(.+?)(\[/code\]),<BLOCKQUOTE><font size="1" face="$FontFace">code:<\/font><HR><pre>$2</pre><HR><\/BLOCKQUOTE>,isg;
if (($PMUBBImages eq "on") && ($PMOverrideImages ne "yes")) {
$ubbcode =~ s/(\[IMG\])(\S+?)(\[\/IMG\])/ <IMG SRC="$2"> /isg;
}
$ubbcode =~ s/(\[QUOTE\])(.+?)(\[\/QUOTE\])/ <BLOCKQUOTE><font size="1" face="$FontFace">quote:<\/font><HR>$2<HR><\/BLOCKQUOTE>/isg;
$ubbcode =~ s/(\[i\])(.+?)(\[\/i\])/<i>$2<\/i>/isg;
$ubbcode =~ s/(\[b\])(.+?)(\[\/b\])/<b>$2<\/b>/isg;

return ($ubbcode);

}
1;