#!/usr/bin/perl
# FriendsOnline 0.9c
# based on Clarn's Message Center v2

# Required Librariers
# --------------------------------------------------------
eval {
    ($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1");    # Get the script location: UNIX /
    ($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1");    # Get the script location: Windows \
	require "buddy.cfg";
    	require "buddy.pl";
   	 require "ubb_library.pl";
	require "ubb_library2.pl";
	require "Styles.file";
	require "UltBB.setup";
	require "mail-lib.pl";
	require "Date.pl";
  if ($Version < 5.44) {
     require "cookie-lib.pl";
  }
};

use Socket;

#adjust bgcolor variables
if ($AltColumnColor2 ne ""){
$AltColumnColor2 = qq(bgcolor="$AltColumnColor2");
}
if ($PageBackground ne ""){
$PageBackground = qq(background="$NonCGIURL/$PageBackground");
}

#Code Checking
if ($PMHTMLAllow eq "yes") {
	$ISHTML = "*HTML is ON";
}  else {
	$ISHTML = "*HTML is OFF";
}
 
if ($PMUBBCodeAllow eq "yes") {
	$ISUBB = "*UBB Code is ON";
}  else {
	$ISUBB = "*UBB Code is OFF";
}

if (($PMUBBImages eq "no") && ($PMUBBCodeAllow eq "yes")) {
	$UBBImagesWording = "\[IMG\] UBB Code Not Allowed!";
}



local (%in) = &parse_form;

		$user = $in{'user'};
		$user = &unhtmlify($user);
		$pass = $in{'pass'};
		$pass = &unhtmlify($pass);
		$to = $in{'sendto'};
		$to = &unhtmlify($to);
		$prsubject = $in{'subject'};
		$prsubject = &unhtmlify($prsubject);
		$prmessage = $in{'message'};
		$prmessage = &unhtmlify($prmessage);
		$idnum = $in{'id'};

		$MsgIcon = $in{'MsgIcon'};
		if ($MsgIcon !~ /(\d|\d\d)/) {
		$MsgIcon = "01";
		}
		
		$urluser = &htmlify($user);
		$urluser =~ tr/ /+/;
		$urlpass = &htmlify($pass);
		$urlpass =~ tr/ /+/;
		
&get_cookie;
unless (($cookie{'UserName'} eq "") or ($cookie{'Password'} eq "")) {
$user = $cookie{'UserName'};
$pass = $cookie{'Password'};
}

&GetDateTime;

if ($DateFormat eq "US") {
	$date = $HyphenDate;
}
elsif ($DateFormat eq "Euro") {
	$date = "$EuroDate"
}
elsif ($DateFormat eq "USX") {
	$date = &DateFormat("$HyphenDate", "USExpanded");
} else {
	$date = &DateFormat("$HyphenDate", "EuroExpanded");
}

#format time
if ($TimeFormat eq "24HR") {
@timearray = split(/ /, $Time);
chomp($timearray[1]);
($gethour, $getmin) = split(/:/, $timearray[0]);
if ($timearray[1] eq "PM") { 
if ($gethour < 12) {
$gethour = ($gethour + 12);
}
}
if ($AMpm eq "AM") { 
if ($gethour == 12) {
$gethour = "0";
}
}
$gethour = sprintf ("%2d", $gethour);
$gethour =~tr/ /0/;
$getmin = sprintf ("%2d", $getmin);
$getmin =~tr/ /0/;
$time = "$gethour:$getmin";
} else {
$time = "$Time";
}

if (-e "$db_dir/$to.pref") {
	open (PREFS,"$db_dir/$to.pref");
    LINE: while(<PREFS>){
		next LINE if (/^#/);		# Skip comment lines.
		next LINE if (/^\s*$/);		# Skip blank lines.
        @data=split (/\|/);
		$prefs{$data[0]} = $data[1];
		$prefs{$data[2]} = $data[3];
	}
   close (PREFS);
}

$prsubject =~ s/\|//g;
$prmessage =~ s/\|//g;

$prmessage =~ s/\r//g;
$prmessage =~ s/\<br\>/\n/g;

$prsubject =~ s/</&lt;/g;
$prsubject =~ s/>/&gt;/g;

if ($PMUBBCodeAllow eq "yes") {
$prmessage = &ubbcode("$prmessage");
}

if ($in{'action'} eq "reply") {
open (REVIEWS,"<$db_dir/$user.db") or &cgierr("unable to open $db_dir/$user.db. Reason: $!");
        LINE: while(<REVIEWS>){
		next LINE if (/^#/);		# Skip comment lines.
		next LINE if (/^\s*$/);		# Skip blank lines.
        @data=split (/\|/);
        if ($idnum eq $data[0]){
		$to = $data[2];
		$prsubject = $data[3];
		$prmessage = $data[4];
		$prsubject = &unhtmlify("$prsubject");  	    
		$prmessage = &unhtmlify("$prmessage");
		$prmessage =~ s/\<br\>/\n/g;
		$prsubject =~ s/^Re: //;
		$prsubject = "Re: $prsubject";
		$prmessage = "\n\n----- Original Message -----\n$prmessage";
		$prmessage =~ s/<p>/\n\r\n/isg;
		$prmessage =~ s/<br>/\n/isg;
		$prmessage = &EditUBBConvert("$prmessage");
		} # End of if
       } #end of while
       close (REVIEWS);
&msgwindow;
}

if ($in{'action'} eq $null) {
&msgwindow;
}

if ($in{'action'} eq "forward") {
open (REVIEWS,"<$db_dir/$user.db") or &cgierr("unable to open $db_dir/$user.db. Reason: $!");
        LINE: while(<REVIEWS>){
		next LINE if (/^#/);		# Skip comment lines.
		next LINE if (/^\s*$/);		# Skip blank lines.
        @data=split (/\|/);
        if ($idnum eq $data[0]){
		$forwarded = $data[2];
		if ($forwarded eq "sent123456"){
			$forwarded = "$user";
		}
		$prsubject = $data[3];
		$prmessage = $data[4];
		$prsubject = &unhtmlify("$prsubject");
		$prmessage = &unhtmlify("$prmessage");
		$prmessage =~ s/\<br\>/\n/g;
		$prsubject =~ s/^Fwd: //;
		$prsubject = "Fwd: $prsubject";
		$prmessage = "\n\n----- Message Forwarded from $forwarded -----\n$prmessage";
		$prmessage =~ s/<p>/\n\r\n/isg;
		$prmessage =~ s/<br>/\n/isg;
		$prmessage = &EditUBBConvert("$prmessage");
		} # End of if
       } #end of while
       close (REVIEWS);
&msgwindow;
}



if ($in{'action'} eq "send") {
&valid_user;
&valid_pass;
&valid_recip;

if ($PMHTMLAllow eq "no") {
		$prmessage =~ s/</&lt;/g;
		$prmessage =~ s/>/&gt;/g;
		$prsubject =~ s/</&lt;/g;
		$prsubject =~ s/>/&gt;/g;	
		$sig =~ s/</&lt;/g;
		$sig =~ s/>/&gt;/g;			
 }
 
if ($in{'Signature'} eq "yes") {
$sig =~ s/(\[IMG\])(\S+?)(\[\/IMG\])/ Images not allowed in sigline /isg;
$sig = &ubbcode("$sig");
$prmessage .= ("\n\n------------------\n$sig");
}

$prmessage = &Smilies("$prmessage");
$prsubject = &htmlify("$prsubject");
$prmessage = &htmlify("$prmessage");

if ($PMCensorOverride eq "no") {
$prsubject = &CensorCheck("$prsubject");
$prmessage = &CensorCheck("$prmessage");
}

&send;

#--- email notification --------
$ProfNumber = &GetUserNumber($to);
@TheProfile = &OpenProfile("$ProfNumber.cgi");
$sendto = $TheProfile[2];
chomp($sendto);
$subject = "Du hast eine privateMessage bekommen!";

if (($sendto =~ /\S+\@\S+\.\S+/) && ($prefs{'email'} eq "yes") && ($AllowPmEmail eq "yes")) {

if ($PmEmailMessage ne "") {
$PmEmailMessage = "$PmEmailMessage\n\r\n";
}

$message = qq(Hallo, $to!\nOn $date $time, $user hat Dir im $BBName eine privateMessage geschickt . Das Thema ist "$prsubject". Du kannst Sie Dir unter $cgi_url/$viewprivate ansehen.\n\r\n $PmEmailMessage Diese Nachricht wird niemals unaufgefordert versandt! Wenn Du die eMail-Benachrichtigung fr privateMessages nicht mehr erhalten mchtest, gehe bitte auf $cgi_url/$privateprefs);

if ($SMTPEmail eq "On") {
&SendEmail;
}  else {
&send_mail("$BBEmail", "$sendto", "$subject", "$message");
}
}
#--- end email notification ----

&send_success;

exit;
}


sub msgwindow {
if ($AllowIcons eq "TRUE") {
$IconWording = &IconFieldHTML;
}  else {
$IconWording = "";
}
$prmessage =~ s/\&lt\;br\&gt\;/\n/g;

$mlwording = "";
if ($memlist eq "yes") {
$mlwording = qq(&nbsp;&nbsp;<font size="1" face=$FontFace><a href="$CGIURL/memberlist.cgi" target="_blank">Mitgliederliste</a></font></A>);
}

&print_header1;
print<<REQUEST_FORM;
<HTML><HEAD>$HeaderInsert<TITLE>FriendOnline hinzufuegen</TITLE></HEAD>
<body text="$TextColor" bgcolor=$BGColor $PageBackground link=$LinkColor alink=$ActiveLinkColor vlink=$VisitedLinkColor>
<form action="$cgi_url/$sendprivate" method="POST">
<input type=hidden name=action value=send>
<font face=$FontFace size=$TextSize>
<br>
<center>
<table border=1 cellpadding=0 cellspacing=0 width=89%>
<tr align=left><td><font face=Verdana, Arial SIZE="1" color="#cecece"><A HREF="$cgi_url/$viewprivate?user=$urluser&pass=$urlpass">FriendsOnline</ACRONYM></A><img src="http://213.155.69.24/ubb/forward_icon.gif" border="0"><font face=Verdana, Arial SIZE="1" color="#cecece">Friend hinzufuegen</font></td></tr></table>
<br><br></center>
<p>
<center>
<table border=0 cellpadding=1 cellspacing=1 width=89% align=center>
<tr $AltColumnColor2><td valign=top><font face=$FontFace size=$TextSize><B>Your Username:</B></td><td valign=top><input type=text name=user size=30 value="$user"></td></tr>
<tr $AltColumnColor2><td valign=top><font face=$FontFace size=$TextSize><B>Your Password:</B></td><td valign=top><input type=password name=pass size=30 value="$pass"></font></td></tr>
<tr $AltColumnColor2><td valign=top><font face=$FontFace size=$TextSize><B>Your Friends Username:</B></td><td><input type=text name=sendto size=30 value="$to">$mlwording</td></tr>
</td>
</tr>
</table>
</center>
<P>
<CENTER>
<input type=submit value="Yo!">
</form>

</BODY></HTML>

REQUEST_FORM
&print_footer;
}


###################################################################
sub send {
###################################################################
$too=$to;

&get_count;
#unless ($count) {
#$count=0;
#$ID=0;
#}
&up_count;

   open (DB,">>$db_dir/$to.db") or &resend;
   flock DB, $EXCLUSIVE;        # Lock the file so nobody else uses it.
    seek DB, 0, 2;
    print DB "$count|$too|$user|$prsubject|$prmessage|$date $time|Yes|$MsgIcon\n";
   flock DB, $UNLOCK;
   close(DB);
   


if ($prefs{'layout'} ne "none") {
&get_count_sent;
&up_count_sent;
  
   # sends copy to sendee
   open (DB,">>$db_dir/$user.db") or &resendcopy;
   flock DB, $EXCLUSIVE;        # Lock the file so nobody else uses it.
    seek DB, 0, 2;
    print DB "$countsent|$too|sent123456|$prsubject|$prmessage|$date $time|Yes|$MsgIcon\n";
   flock DB, $UNLOCK;
   close(DB);


}   
}

sub send_success{
$prmessage =~ s/\n/<BR>/g;

&print_header1;
print<<REQUEST_FORM;
<HTML><HEAD>$HeaderInsert
<meta http-equiv="Refresh" content="2; URL=$cgi_url/$viewprivate?user=$urluser&pass=$urlpass">
</HEAD>
<body text="$TextColor" bgcolor=$BGColor $PageBackground link=$LinkColor alink=$ActiveLinkColor vlink=$VisitedLinkColor>
<br><br>
<font face=$FontFace size=$TextSize>
<ul><FONT COLOR=$TimeColor>
<B>Forward zur BuddyListe bzw. FriendSystem</B>
<br><br></font>
<A HREF="$cgi_url/$viewprivate?user=$urluser&pass=$urlpass">Klick or wait!</A>
</ul></body></html>
REQUEST_FORM

&print_footer;
}
###################################################################
sub resend {
###################################################################
$too=$to;

   open (DB,">$db_dir/$to.db") or &cgierr;
   flock DB, $EXCLUSIVE;        # Lock the file so nobody else uses it.
    seek DB, 0, 2;
    print DB "$count|$too|$user|$prsubject|$prmessage|$date $time|Yes\n";
   flock DB, $UNLOCK;
   close(DB);
   
   
}

###################################################################
sub resendcopy {
###################################################################
$too=$to;

   open (DB,">$db_dir/$user.db") or &cgierr;
   flock DB, $EXCLUSIVE;        # Lock the file so nobody else uses it.
    seek DB, 0, 2;
    print DB "$countsent|$too|sent123456|$prsubject|$prmessage|$date $time|Yes\n";
   flock DB, $UNLOCK;
   close(DB);
   
   
}